export class Scheduler {
  constructor() {
    if (this.constructor === Scheduler) {
      throw new Error('Scheduler es una clase abstracta')
    }
  }

  calculateNextInterval(card, quality, currentDate) {
    throw new Error('Método calculateNextInterval debe ser implementado por las clases hijas')
  }

  getCardsToReview(cards, currentDate) {
    // Filtra las tarjetas que necesitan revisión (fecha de revisión <= fecha actual)
    const cardsToReview = cards.filter(card => card.getNextReview() <= currentDate)
    
    // Ordena las tarjetas por fecha de revisión (las más antiguas primero)
    return cardsToReview.sort((a, b) => a.getNextReview() - b.getNextReview())
  }
} 